#define WIN32_LEAN_AND_MEAN

#include <windows.h>

INT WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, INT)
{
	STARTUPINFO sinf;
	PROCESS_INFORMATION pinf;

	ZeroMemory(&sinf,sizeof(sinf));
	sinf.cb = sizeof(sinf);
	sinf.dwFlags = STARTF_USESHOWWINDOW;
	sinf.wShowWindow = SW_SHOWNORMAL;

	char App[21] = ".\\Bin\\xrEngine.exe\0";

	if (!CreateProcess(App, 0, 0, 0, FALSE, NORMAL_PRIORITY_CLASS, 0, 0, &sinf, &pinf)) // Use parent's starting directory.
	{
		MessageBox(0,"Couldn't create process.\r Place this file to Stalker dir.", "Error", MB_ICONERROR);
		return 1;
	}


	//startup function for thread
	DWORD threadid;
	PTHREAD_START_ROUTINE pfnThreadRtn =
		(PTHREAD_START_ROUTINE) GetProcAddress(GetModuleHandle("kernel32"), "LoadLibraryA");

	if (!pfnThreadRtn)
	{
		MessageBox(0,"Couldn't find kernel32.","Error",MB_ICONERROR);
		return 1;
	}

    // allocate string in target process with lib name, and write it 
	char *pszLibFileRemote = (char*) 
		VirtualAllocEx(pinf.hProcess, NULL, MAX_PATH, MEM_COMMIT, PAGE_READWRITE);

	if (!WriteProcessMemory(pinf.hProcess, pszLibFileRemote, 
		"fakekernel32.dll", MAX_PATH, NULL))
	{
		MessageBox(0,"Couldn't find fakekernel32.dll. \r Place this file to Stalker dir.","Error",MB_ICONERROR);
		return 1;
	}

	//this thread load fake lib in app. mem. space 
	HANDLE hThread =
		CreateRemoteThread(pinf.hProcess, NULL, 0, pfnThreadRtn, pszLibFileRemote, 0, &threadid);

	if(hThread == INVALID_HANDLE_VALUE)
	{
		MessageBox(0,"Couldn't create thread", "Error", MB_ICONERROR);
		return 1;
	}


	// wait when app. close and free alloc. mem
	WaitForSingleObject(hThread, INFINITE);
	VirtualFreeEx(pinf.hProcess, pszLibFileRemote, 0, MEM_RELEASE);
	CloseHandle(hThread);

	return 0;
}