#include "stdafx.h"


void __stdcall MyGetSystemInfo(LPSYSTEM_INFO sysInf)
{
	GetSystemInfo(sysInf);
	sysInf->lpMaximumApplicationAddress = (LPVOID)0xbffeffff;
}

BOOL __stdcall MyGlobalMemoryStatusEx(LPMEMORYSTATUSEX  MemStat)
{
	BOOL Res = GlobalMemoryStatusEx(MemStat);
	//MemStat->ullAvailPageFile += 1073741824;
	MemStat->ullTotalVirtual = 4294967296;//+= 1073741824;
	return Res;
}


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	if (ul_reason_for_call == DLL_PROCESS_ATTACH)
	{
		PROC Mproc = GetProcAddress(GetModuleHandle("kernel32.dll"), "GetSystemInfo");
		HMODULE hmodCaller = GetModuleHandle("xrEngine.exe");
		ReplaceIAT("kernel32.dll", Mproc, (PROC)MyGetSystemInfo, hmodCaller);

		Mproc = GetProcAddress(GetModuleHandle("kernel32.dll"), "GlobalMemoryStatusEx");
		ReplaceIAT("kernel32.dll", Mproc, (PROC)MyGlobalMemoryStatusEx, hmodCaller);
	}
    return TRUE;
}



void ReplaceIAT(PCSTR pszCalleeModName, PROC pfnCurrent, PROC pfnNew, HMODULE hmodCaller)
{ 
	ULONG ulSize;
	PIMAGE_IMPORT_DESCRIPTOR pImportDesc = (PIMAGE_IMPORT_DESCRIPTOR) ImageDirectoryEntryToData(hmodCaller, TRUE,IMAGE_DIRECTORY_ENTRY_IMPORT, &ulSize); 
	if (pImportDesc == NULL) 
		return; 

	for (; pImportDesc->Name; pImportDesc++) 
	{ 
		PSTR pszModName = (PSTR) ((PBYTE) hmodCaller + pImportDesc->Name); 
		if (lstrcmpiA(pszModName, pszCalleeModName) == 0) 
			break; 
	} 
	if (pImportDesc->Name == 0) return; 
		PIMAGE_THUNK_DATA pThunk = (PIMAGE_THUNK_DATA) ((PBYTE) hmodCaller + pImportDesc->FirstThunk); 
		for (; pThunk->u1.Function; pThunk++) 
		{
			PROC* ppfn = (PROC*) &pThunk->u1.Function;
			BOOL fFound = (*ppfn == pfnCurrent);
			if (fFound) 
			{ 
				
				DWORD dwOrgProtect, wr;
				VirtualProtect( ppfn, sizeof(pfnNew), PAGE_READWRITE, &dwOrgProtect );
				WriteProcessMemory(GetCurrentProcess(), ppfn, &pfnNew, sizeof(pfnNew), &wr ); 
				VirtualProtect( ppfn, sizeof(pfnNew), dwOrgProtect , &dwOrgProtect );
					
				return;
			} 
		} 
}